home *** CD-ROM | disk | FTP | other *** search
/ Personal Computer World 2009 February / PCWFEB09.iso / Software / Linux / Kubuntu 8.10 / kubuntu-8.10-desktop-i386.iso / casper / filesystem.squashfs / usr / bin / startkde < prev    next >
Text File  |  2008-10-24  |  16KB  |  444 lines

  1. #!/bin/sh
  2. #
  3. #  DEFAULT KDE STARTUP SCRIPT ( 4.1.2 (KDE 4.1.2) )
  4. #
  5.  
  6. # When the X server dies we get a HUP signal from xinit. We must ignore it
  7. # because we still need to do some cleanup.
  8. trap 'echo GOT SIGHUP' HUP
  9.  
  10. # Check if a KDE session already is running and whether it's possible to connect to X
  11. kcheckrunning
  12. kcheckrunning_result=$?
  13. if test $kcheckrunning_result -eq 0 ; then
  14.     echo "KDE seems to be already running on this display."
  15.     xmessage -geometry 500x100 "KDE seems to be already running on this display." > /dev/null 2>/dev/null
  16.     exit 1
  17. elif test $kcheckrunning_result -eq 2 ; then
  18.     echo "\$DISPLAY is not set or cannot connect to the X server."
  19.         exit 1
  20. fi
  21.  
  22. # Set the background to plain grey.
  23. # The standard X background is nasty, causing moire effects and exploding
  24. # people's heads. We use colours from the standard KDE palette for those with
  25. # palettised displays.
  26. if test -z "$XDM_MANAGED" || echo "$XDM_MANAGED" | grep ",auto" > /dev/null; then
  27.   xsetroot -solid "#000000"
  28. fi
  29.  
  30. # we have to unset this for Darwin since it will screw up KDE's dynamic-loading
  31. unset DYLD_FORCE_FLAT_NAMESPACE
  32.  
  33. # in case we have been started with full pathname spec without being in PATH
  34. bindir=`echo "$0" | sed -n 's,^\(/.*\)/[^/][^/]*$,\1,p'`
  35. if [ -n "$bindir" ]; then
  36.   qbindir=`$bindir/kde4-config --qt-binaries`
  37.   if [ -n "$qbindir" ]; then
  38.     case $PATH in
  39.       $qbindir|$qbindir:*|*:$qbindir|*:$qbindir:*) ;;
  40.       *) PATH=$qbindir:$PATH; export PATH;;
  41.     esac
  42.   fi
  43.   case $PATH in
  44.     $bindir|$bindir:*|*:$bindir|*:$bindir:*) ;;
  45.     *) PATH=$bindir:$PATH; export PATH;;
  46.   esac
  47. fi
  48.  
  49. # Boot sequence:
  50. #
  51. # kdeinit is used to fork off processes which improves memory usage
  52. # and startup time.
  53. #
  54. # * kdeinit starts klauncher first.
  55. # * Then kded is started. kded is responsible for keeping the sycoca
  56. #   database up to date. When an up to date database is present it goes
  57. #   into the background and the startup continues.
  58. # * Then kdeinit starts kcminit. kcminit performs initialisation of
  59. #   certain devices according to the user's settings
  60. #
  61. # * Then ksmserver is started which takes control of the rest of the startup sequence
  62.  
  63. # The user's personal KDE directory is usually ~/.kde, but this setting
  64. # may be overridden by setting KDEHOME.
  65.  
  66. kdehome=$HOME/.kde
  67. test -n "$KDEHOME" && kdehome=`echo "$KDEHOME"|sed "s,^~/,$HOME/,"`
  68.  
  69. # see kstartupconfig source for usage
  70. mkdir -m 700 -p $kdehome
  71. mkdir -m 700 -p $kdehome/share
  72. mkdir -m 700 -p $kdehome/share/config
  73. cat >$kdehome/share/config/startupconfigkeys <<EOF
  74. kcminputrc Mouse cursorTheme 'Oxygen_Black'
  75. kcminputrc Mouse cursorSize ''
  76. ksplashrc KSplash Theme Default
  77. ksplashrc KSplash Engine KSplashX
  78. kcmrandrrc Display ApplyOnStartup false
  79. kcmrandrrc [Screen0]
  80. kcmrandrrc [Screen1]
  81. kcmrandrrc [Screen2]
  82. kcmrandrrc [Screen3]
  83. kcmfonts General forceFontDPI 0
  84. kdeglobals Locale Language '' # trigger requesting languages from KLocale
  85. EOF
  86. kstartupconfig4
  87. if test $? -ne 0; then
  88.     xmessage -geometry 500x100 "Could not start kstartupconfig4. Check your installation."
  89.     exit 1
  90. fi
  91. [ -r $kdehome/share/config/startupconfig ] && . $kdehome/share/config/startupconfig
  92.  
  93. # XCursor mouse theme needs to be applied here to work even for kded or ksmserver
  94. if test -n "$kcminputrc_mouse_cursortheme" -o -n "$kcminputrc_mouse_cursorsize" ; then
  95.     
  96.  
  97.     kapplymousetheme "$kcminputrc_mouse_cursortheme" "$kcminputrc_mouse_cursorsize"
  98.     if test $? -eq 10; then
  99.         XCURSOR_THEME=default
  100.         export XCURSOR_THEME
  101.     elif test -n "$kcminputrc_mouse_cursortheme"; then
  102.         XCURSOR_THEME="$kcminputrc_mouse_cursortheme"
  103.         export XCURSOR_THEME
  104.     fi
  105.     if test -n "$kcminputrc_mouse_cursorsize"; then
  106.         XCURSOR_SIZE="$kcminputrc_mouse_cursorsize"
  107.         export XCURSOR_SIZE
  108.     fi
  109. fi
  110.  
  111. if test "$kcmrandrrc_display_applyonstartup" = "true"; then
  112.     # 4 screens is hopefully enough
  113.     for scrn in 0 1 2 3; do
  114.         args=
  115.         width="\$kcmrandrrc_screen${scrn}_width" ; eval "width=$width"
  116.         height="\$kcmrandrrc_screen${scrn}_height" ; eval "height=$height"
  117.         if test -n "${width}" -a -n "${height}"; then
  118.             args="$args -s ${width}x${height}"
  119.         fi
  120.         refresh="\$kcmrandrrc_screen${scrn}_refresh" ; eval "refresh=$refresh"
  121.         if test -n "${refresh}"; then
  122.             args="$args -r ${refresh}"
  123.         fi
  124.         rotation="\$kcmrandrrc_screen${scrn}_rotation" ; eval "rotation=$rotation"
  125.         if test -n "${rotation}"; then
  126.             case "${rotation}" in
  127.                 0)
  128.                     args="$args -o 0"
  129.                     ;;
  130.                 90)
  131.                     args="$args -o 1"
  132.                     ;;
  133.                 180)
  134.                     args="$args -o 2"
  135.                     ;;
  136.                 270)
  137.                     args="$args -o 3"
  138.                     ;;
  139.             esac
  140.         fi
  141.         reflectx="\$kcmrandrrc_screen${scrn}_reflectx" ; eval "reflectx=$reflectx"
  142.         if test "${refrectx}" = "true"; then
  143.             args="$args -x"
  144.         fi
  145.         reflecty="\$kcmrandrrc_screen${scrn}_reflecty" ; eval "reflecty=$reflecty"
  146.         if test "${refrecty}" = "true"; then
  147.             args="$args -y"
  148.         fi
  149.         if test -n "$args"; then
  150.             xrandr $args
  151.         fi
  152.     done
  153. fi
  154.  
  155. if test "$kcmfonts_general_forcefontdpi" -eq 120; then
  156.     xrdb -quiet -merge -nocpp <<EOF
  157. Xft.dpi: 120
  158. EOF
  159. elif test "$kcmfonts_general_forcefontdpi" -eq 96; then
  160.     xrdb -quiet -merge -nocpp <<EOF
  161. Xft.dpi: 96
  162. EOF
  163. fi
  164.  
  165.  
  166. dl=$DESKTOP_LOCKED
  167. unset DESKTOP_LOCKED # Don't want it in the environment
  168.  
  169. ksplash_pid=
  170. if test -z "$dl"; then
  171.   # languages as resolved by KLocale, for the splash screens use
  172.   # klocale_languages is assembled by kdostartupconfig4 calling KLocale
  173.   KLOCALE_LANGUAGES="$klocale_languages"
  174.   export KLOCALE_LANGUAGES
  175.   # the splashscreen and progress indicator
  176.   case "$ksplashrc_ksplash_engine" in
  177.     KSplashX)
  178.       ksplash_pid=`ksplashx ${ksplashrc_ksplash_theme} --pid`
  179.       ;;
  180.     None)
  181.       ;;
  182.     Simple)
  183.       ksplash_pid=`ksplashsimple ${ksplashrc_ksplash_theme} --pid`
  184.       ;;
  185.     *)
  186.       ;;
  187.   esac
  188.   # no longer needed in the environment
  189.   unset KLOCALE_LANGUAGES
  190. fi
  191.  
  192. # configuration of the gtk_qt_engine if not already set
  193.  
  194. if [ ! -e $kdehome/env/gtk-qt-engine.rc.sh ] && [ -e /usr/share/kubuntu-default-settings/gtk-qt-engine.rc.sh ]
  195. then
  196.  mkdir -p $kdehome/env
  197.  cp -f /usr/share/kubuntu-default-settings/gtk-qt-engine.rc.sh $kdehome/env
  198.  chmod 755 $kdehome/env/gtk-qt-engine.rc.sh
  199. fi
  200.  
  201. if [ ! -e $HOME/.gtkrc-2.0-kde4 ] && [ -e /usr/share/kubuntu-default-settings/dot-gtkrc-2.0-kde4 ]
  202. then
  203.  cp -f /usr/share/kubuntu-default-settings/dot-gtkrc-2.0-kde4 $HOME/.gtkrc-2.0-kde4
  204. fi
  205.  
  206. # Source scripts found in <localprefix>/env/*.sh and <prefixes>/env/*.sh
  207. # (where <localprefix> is $KDEHOME or ~/.kde, and <prefixes> is where KDE is installed)
  208. #
  209. # This is where you can define environment variables that will be available to
  210. # all KDE programs, so this is where you can run agents using e.g. eval `ssh-agent`
  211. # or eval `gpg-agent --daemon`.
  212. # Note: if you do that, you should also put "ssh-agent -k" as a shutdown script
  213. #
  214. # (see end of this file).
  215. # For anything else (that doesn't set env vars, or that needs a window manager),
  216. # better use the Autostart folder.
  217.  
  218. libpath=`kde4-config --path lib | tr : '\n'`
  219.  
  220. for prefix in `echo "$libpath" | sed -n -e 's,/lib[^/]*/,/env/,p'`; do
  221.   for file in "$prefix"*.sh; do
  222.     test -r "$file" && . "$file"
  223.   done
  224. done
  225.  
  226. # Set the path for Qt plugins provided by KDE
  227. if test -n "$QT_PLUGIN_PATH"; then
  228.   QT_PLUGIN_PATH="$QT_PLUGIN_PATH:`kde4-config --path qtplugins`"
  229. else
  230.   QT_PLUGIN_PATH="`kde4-config --path qtplugins`"
  231. fi
  232. export QT_PLUGIN_PATH
  233.  
  234. # Activate the kde font directories.
  235. #
  236. # There are 4 directories that may be used for supplying fonts for KDE.
  237. #
  238. # There are two system directories. These belong to the administrator.
  239. # There are two user directories, where the user may add her own fonts.
  240. #
  241. # The 'override' versions are for fonts that should come first in the list,
  242. # i.e. if you have a font in your 'override' directory, it will be used in
  243. # preference to any other.
  244. #
  245. # The preference order looks like this:
  246. # user override, system override, X, user, system
  247. #
  248. # Where X is the original font database that was set up before this script
  249. # runs.
  250.  
  251. usr_odir=$HOME/.fonts/kde-override
  252. usr_fdir=$HOME/.fonts
  253.  
  254. if test -n "$KDEDIRS"; then
  255.   kdedirs_first=`echo "$KDEDIRS"|sed -e 's/:.*//'`
  256.   sys_odir=$kdedirs_first/share/fonts/override
  257.   sys_fdir=$kdedirs_first/share/fonts
  258. else
  259.   sys_odir=$KDEDIR/share/fonts/override
  260.   sys_fdir=$KDEDIR/share/fonts
  261. fi
  262.  
  263. # We run mkfontdir on the user's font dirs (if we have permission) to pick
  264. # up any new fonts they may have installed. If mkfontdir fails, we still
  265. # add the user's dirs to the font path, as they might simply have been made
  266. # read-only by the administrator, for whatever reason.
  267.  
  268. test -d "$sys_odir" && xset +fp "$sys_odir"
  269. test -d "$usr_odir" && (mkfontdir "$usr_odir" ; xset +fp "$usr_odir")
  270. test -d "$usr_fdir" && (mkfontdir "$usr_fdir" ; xset fp+ "$usr_fdir")
  271. test -d "$sys_fdir" && xset fp+ "$sys_fdir"
  272.  
  273. # Ask X11 to rebuild its font list.
  274. xset fp rehash
  275.  
  276. # Set a left cursor instead of the standard X11 "X" cursor, since I've heard
  277. # from some users that they're confused and don't know what to do. This is
  278. # especially necessary on slow machines, where starting KDE takes one or two
  279. # minutes until anything appears on the screen.
  280. #
  281. # If the user has overwritten fonts, the cursor font may be different now
  282. # so don't move this up.
  283. #
  284. xsetroot -cursor_name left_ptr
  285.  
  286. # Get Ghostscript to look into user's KDE fonts dir for additional Fontmap
  287. if test -n "$GS_LIB" ; then
  288.     GS_LIB=$usr_fdir:$GS_LIB
  289.     export GS_LIB
  290. else
  291.     GS_LIB=$usr_fdir
  292.     export GS_LIB
  293. fi
  294.  
  295. lnusertemp=`kde4-config --path exe --locate lnusertemp`
  296. if test -z "$lnusertemp"; then
  297.   # Startup error
  298.   echo 'startkde: ERROR: Could not locate lnusertemp in '`kde4-config --path exe` 1>&2
  299. fi
  300.  
  301. # Link "tmp" "socket" and "cache" resources to directory in /tmp
  302. # Creates:
  303. # - a directory /tmp/kde-$USER and links $KDEHOME/tmp-$HOSTNAME to it.
  304. # - a directory /tmp/ksocket-$USER and links $KDEHOME/socket-$HOSTNAME to it.
  305. # - a directory /var/tmp/kdecache-$USER and links $KDEHOME/cache-$HOSTNAME to it.
  306. # Note: temporary locations can be overriden through the KDETMP and KDEVARTMP
  307. # environment variables
  308. for resource in tmp cache socket; do
  309.     if ! "$lnusertemp" $resource >/dev/null; then
  310.         echo 'startkde: Call to lnusertemp failed (temporary directories full?). Check your installation.'  1>&2
  311.         test -n "$ksplash_pid" && kill "$ksplash_pid" 2>/dev/null
  312.         xmessage -geometry 600x100 "Call to lnusertemp failed (temporary directories full?). Check your installation."
  313.         exit 1
  314.     fi
  315. done
  316.  
  317. # In case of dcop sockets left by a previous session, cleanup
  318. #dcopserver_shutdown
  319.  
  320. echo 'startkde: Starting up...'  1>&2
  321.  
  322. # Make sure that D-Bus is running
  323. if test -z "$XDG_DATA_DIRS"; then
  324.     XDG_DATA_DIRS="`kde4-config --prefix`/share:/usr/share:/usr/local/share"
  325.     export XDG_DATA_DIRS
  326. fi
  327. # D-Bus autolaunch is broken
  328. if test -z "$DBUS_SESSION_BUS_ADDRESS" ; then
  329.     eval `dbus-launch --sh-syntax --exit-with-session`
  330. fi
  331. if qdbus >/dev/null 2>/dev/null; then
  332.     : # ok
  333. else
  334.     echo 'startkde: Could not start D-Bus. Check your installation.'  1>&2
  335.     test -n "$ksplash_pid" && kill "$ksplash_pid" 2>/dev/null
  336.     xmessage -geometry 500x100 "Could not start D-Bus. Check your installation."
  337.     exit 1
  338. fi
  339.  
  340.  
  341. # Mark that full KDE session is running (e.g. Konqueror preloading works only
  342. # with full KDE running). The KDE_FULL_SESSION property can be detected by
  343. # any X client connected to the same X session, even if not launched
  344. # directly from the KDE session but e.g. using "ssh -X", kdesu. $KDE_FULL_SESSION
  345. # however guarantees that the application is launched in the same environment
  346. # like the KDE session and that e.g. KDE utilities/libraries are available.
  347. # KDE_FULL_SESSION property is also only available since KDE 3.5.5.
  348. # The matching tests are:
  349. #   For $KDE_FULL_SESSION:
  350. #     if test -n "$KDE_FULL_SESSION"; then ... whatever
  351. #   For KDE_FULL_SESSION property:
  352. #     xprop -root | grep "^KDE_FULL_SESSION" >/dev/null 2>/dev/null
  353. #     if test $? -eq 0; then ... whatever
  354. #
  355. # Additionally there is (since KDE 3.5.7) $KDE_SESSION_UID with the uid
  356. # of the user running the KDE session. It should be rarely needed (e.g.
  357. # after sudo to prevent desktop-wide functionality in the new user's kded).
  358. #
  359. # Since KDE4 there is also KDE_SESSION_VERSION, containing the major version number.
  360. # Note that this didn't exist in KDE3, which can be detected by its absense and
  361. # the presence of KDE_FULL_SESSION.
  362. #
  363. KDE_FULL_SESSION=true
  364. export KDE_FULL_SESSION
  365. xprop -root -f KDE_FULL_SESSION 8t -set KDE_FULL_SESSION true
  366.  
  367. KDE_SESSION_VERSION=4
  368. export KDE_SESSION_VERSION
  369. xprop -root -f KDE_SESSION_VERSION 32c -set KDE_SESSION_VERSION 4
  370.  
  371. KDE_SESSION_UID=$UID
  372. export KDE_SESSION_UID
  373.  
  374. # We set LD_BIND_NOW to increase the efficiency of kdeinit.
  375. # kdeinit unsets this variable before loading applications.
  376. LD_BIND_NOW=true kdeinit4 +kcminit_startup
  377. if test $? -ne 0; then
  378.   # Startup error
  379.   echo 'startkde: Could not start kdeinit4. Check your installation.'  1>&2
  380.   test -n "$ksplash_pid" && kill "$ksplash_pid" 2>/dev/null
  381.   xmessage -geometry 500x100 "Could not start kdeinit4. Check your installation."
  382.   exit 1
  383. fi
  384.  
  385. # If the session should be locked from the start (locked autologin),
  386. # lock now and do the rest of the KDE startup underneath the locker.
  387. if test -n "$dl"; then
  388.   kwrapper4 krunner_lock --forcelock &
  389.   # Give it some time for starting up. This is somewhat unclean; some
  390.   # notification would be better.
  391.   sleep 1
  392. fi
  393.  
  394. # finally, give the session control to the session manager
  395. # see kdebase/ksmserver for the description of the rest of the startup sequence
  396. # if the KDEWM environment variable has been set, then it will be used as KDE's
  397. # window manager instead of kwin.
  398. # if KDEWM is not set, ksmserver will ensure kwin is started.
  399. # kwrapper4 is used to reduce startup time and memory usage
  400. # kwrapper4 does not return useful error codes such as the exit code of ksmserver.
  401. # We only check for 255 which means that the ksmserver process could not be 
  402. # started, any problems thereafter, e.g. ksmserver failing to initialize, 
  403. # will remain undetected.
  404. test -n "$KDEWM" && KDEWM="--windowmanager $KDEWM"
  405. kwrapper4 ksmserver $KDEWM 
  406. if test $? -eq 255; then
  407.   # Startup error
  408.   echo 'startkde: Could not start ksmserver. Check your installation.'  1>&2
  409.   test -n "$ksplash_pid" && kill "$ksplash_pid" 2>/dev/null
  410.   xmessage -geometry 500x100 "Could not start ksmserver. Check your installation."
  411. fi
  412.  
  413. # wait if there's any crashhandler shown
  414. while qdbus | grep "^[^w]*org.kde.drkonqi" > /dev/null ; do
  415.     sleep 5
  416. done
  417.  
  418. echo 'startkde: Shutting down...'  1>&2
  419. # just in case
  420. test -n "$ksplash_pid" && kill "$ksplash_pid" 2>/dev/null
  421.  
  422. # Clean up
  423. kdeinit4_shutdown
  424. # KDE3 support
  425. kde3 kdeinit_shutdown 2>/dev/null
  426. kde3 dcopserver_shutdown --wait 2>/dev/null
  427.  
  428. echo 'startkde: Running shutdown scripts...'  1>&2
  429.  
  430. # Run scripts found in $KDEDIRS/shutdown
  431. for prefix in `echo "$libpath" | sed -n -e 's,/lib[^/]*/,/shutdown/,p'`; do
  432.   for file in `ls "$prefix" 2> /dev/null | egrep -v '(~|\.bak)$'`; do
  433.     test -x "$prefix$file" && "$prefix$file"
  434.   done
  435. done
  436.  
  437. unset KDE_FULL_SESSION
  438. xprop -root -remove KDE_FULL_SESSION
  439. unset KDE_SESSION_VERSION
  440. xprop -root -remove KDE_SESSION_VERSION
  441. unset KDE_SESSION_UID
  442.  
  443. echo 'startkde: Done.'  1>&2
  444.